#include "variables.h"

#define debugger(X) { if (debug==1) { printf("(%s) at line %d, "X"\n",__FILE__,__LINE__) ; fflush(stdout); usleep(5000);}}

#define VERSION		"0.99d"
#define MAXLINE		2048
#define VA_LOCAL_DECL   va_list ap;
#define VA_START(f)	va_start(ap)
#define VA_END		va_end(ap)
#define SPT_BUFSIZE   PSARGSZ
/* #define MOREPATH      ":/usr/local/bin:/bin:/usr/bin:/usr/X11R6/bin" */
#define TITLELEN      512
#define DIRLEN		256
#define LOCKFILE      "/tmp/randmp3.lock"
#define SETUPFILE     ".randmp3.set"

#define FUTABASERIAL  "/dev/ttyS0"

#define PORT          1666

#define DSPCHECKTIME	5

#define DEFAULTHOST   "localhost"

#define HEP           "n,j,dn=next N,J,PDn=down-1/2-scrn  b,k,up=prev B,K,PUp=up-1/2-scrn"
#define HEP2          "m=mixsw r=restart p=pause c=cont q,bs,del=quit ra,la=mixadj z=tog rnd"
#define HEPNOAUMIX           "n,j,dn=next N,J,PDn=down-1/2-scrn  b,k,up=prev B,K,PUp=up-1/2-scrn"
#define HEP2NOAUMIX          "r=restart p=pause c=cont q,bs,del=quit z=tog rnd"

#define SHUFFLE       ">> << >> <<"
#define FORWARD       ">> >> >> >>"
#define BACKWARD      "<< << << <<"
#define PAUSESYM      "||"
#define CONTINUE      "->"
#define RANDOM        "random"
#define ORDERED       "ordered"
#define SCRAMBLING    "ScRaMbLiNg"
#define RESETTINGPLAYLIST "resetting play list"
#define CANTDELL      "can't delete last one"

#define DIRLINE       0
#define TITLELINE     2
#define TIMELINE      1
#define SQUIGLINE     3
#define STATUSLINE    4

#define NUMBEROFTITLESTOSHOW 7

#define QUIT   1
#define PAUSE  2
#define RESUME 3
#define NEXT   4
#define PREV   5
#define REPEAT 6
#define QUERY  7

#define MP3 1
#define WAV 2
#define OGG 3
#define NONE 0

#define MAXFORMATS 5
#define MAXPLAYERS 15

#define WHITEONBLACK 0
#define WHITEONBLUE 1
#define BLACKONCYAN 2
#define WHITEONRED 3
#define YELLOWONRED 4
#define WHITEONMAGENTA 4
#define YELLOWONBLUE 6
#define MAGENTAONBLUE 7
#define BLACKONBLUE 8
#define CYANONBLUE 9
#define GREENONBLUE 10
#define REDONBLUE 11
#define YELLOWONWHITE 12
#define REDONWHITE 13
#define BLACKONWHITE 14
#define BLACKONRED 15

