#include "includes.h"
#include "defines.h"
#include "funcs.h"

int srchplayer(char *extension, int phormat)
{
	char *tmpfnd;
	int foundplayer=0;
	int yy=0;

	tmpfnd=calloc(1,256);

	if ((tmpfnd=pathsrch(mp3player[playertouse[phormat]].player))!=NULL)
	{
		player[phormat]=mp3player[playertouse[phormat]].player;
		for (x=0;strlen(mp3player[playertouse[phormat]].playerflags[x])!=0;++x)
			playerflags[x][phormat]=mp3player[playertouse[phormat]].playerflags[x];
		playeroutput[phormat]=mp3player[playertouse[phormat]].playeroutput;
		filefirst[phormat]=mp3player[playertouse[phormat]].filefirst;
		strncat(playerdir[phormat],tmpfnd,(int)((char *)rindex(tmpfnd,'/')-(char *)tmpfnd));
		++foundplayer;
	} else
	{
		printf ("Default player %s for %s not found.  Searching for another player.\n",mp3player[playertouse[phormat]].player,extension);
		for (yy=0;((yy<MAXPLAYERS)&&(player[phormat]==NULL));++yy)
		{
			if (strncmp(mp3player[yy].filetype,extension,3)==0)
			{
				if ((tmpfnd=pathsrch(mp3player[yy].player))!=NULL)
				{
					player[phormat]=mp3player[yy].player;
					strncat(playerdir[phormat],tmpfnd,(int)((char *)rindex(tmpfnd,'/')-(char *)tmpfnd));
					for (x=0;strlen(mp3player[yy].playerflags[x])!=0;++x)
						playerflags[x][phormat]=mp3player[yy].playerflags[x];
					playeroutput[phormat]=mp3player[yy].playeroutput;
					filefirst[phormat]=mp3player[yy].filefirst;
					++foundplayer;
					printf ("Found %s for %s.\n",player[phormat],extension);
				}
			}
		}
		if (player[phormat]==NULL)
		{
			printf("Did NOT find player for %s\n" ,extension);
		}
	}
	free(tmpfnd);
	return (foundplayer);
}

char *findplayers()
{
	int yy;
	char *tmpfnd;

	tmpfnd=calloc(1,256);
	if ((tmpfnd=pathsrch("more"))==NULL)
	{
		if ((tmpfnd=pathsrch("less"))==NULL)
		{
			if ((tmpfnd=pathsrch("pg"))==NULL)
			{
				debugger("Cannot find \"more\", \"less\", or \"pg\" on your system.");
				exit (1);
			} else
			{
				debugger("Found the \"pg\" program.");
				strcpy(more,tmpfnd);
			}
		} else
		{
			debugger("Found the \"less\" program.");
			strcpy(more,tmpfnd);
		}
	} else
	{
		debugger("Found the \"more\" program.");
		strcpy(more,tmpfnd);
	}

/*	if ((tmpfnd=pathsrch("stty"))==NULL)
	{
		debugger("Cannot find \"stty\" on your system.");
		sttypresent=0;
	} else
	{
		debugger("Found the \"stty\" program.");
		sttypresent=1;
	} */

	if ((tmpfnd=pathsrch("aumix"))==NULL)
	{
		debugger("Cannot find \"aumix\" on your system.");
		aumixpresent=0;
	} else
	{
		debugger("Found the \"aumix\" program.");
		aumixpresent=1;
	}

	for (yy=1;yy<=MAXFORMATS;++yy)
	{
		playerdir[yy]=calloc(1,256);
	}

	returnstring=NULL;

	if ( ((srchplayer("mp3",MP3)) + (srchplayer("wav",WAV)) + (srchplayer("ogg",OGG)) ) > 0 )
		return ("yes");
	else
		return (NULL);
}
