#include "includes.h"
#include "defines.h"

void help()
{
char *duh;
FILE *pipey;
pipey=popen("more","w");
duh=calloc(1,1024);
fprintf(pipey,"%s version %s\n\n",iam,(char *)VERSION);
fprintf(pipey,"server options\n");
fprintf(pipey,"%10.10s [-s] [-Q|-d] [-z] [-f] [-D] [-N]\n",iam);
fprintf(pipey,"           [-m #] [-o #] [-w #] [-l dir ... ] [-L dir ... ] [-t port] [-P pwd]\n");
fprintf(pipey,"\n");
fprintf(pipey," -s      step-by-step mode (navigate as usual, then hit enter to play it)\n");
fprintf(pipey," -N      don't check /dev/dsp for open (useful for esd freaks)\n");
fprintf(pipey," -D      debug mode, lots of nasty screen-messing-up stuff\n");
fprintf(pipey," -Q      quiet (for inittabbin' it, control via client)\n");
fprintf(pipey," -d      daemonize, control via client\n");
fprintf(pipey," -z      random order\n");
fprintf(pipey," -P      specify password client must use (optional)\n");
fprintf(pipey," -m x    select mp3 player from table below (default is %s)\n",mp3player[0].player);
fprintf(pipey," -o x    select ogg player from table below (default is %s)\n",mp3player[4].player);
fprintf(pipey," -w x    select wav player from table below (default is %s)\n",mp3player[3].player);
fprintf(pipey,"\n");
for (qq=0;strlen(mp3player[qq].player)!=0;++qq)
	fprintf (pipey,"    %d %15.15s %5.5s %50.50s\n",qq,mp3player[qq].player,
			mp3player[qq].filetype,
			mp3player[qq].comment);
fprintf(pipey,"\n");
fprintf(pipey," -f      use futaba display also\n\n");
fprintf(pipey," -l xxx  use xxx as mp3 directory instead of %s\n",MP3DIRECTORY);
fprintf(pipey,"         You can string several -l together to load several dirs.\n");
fprintf(pipey,"         e.g. jooky -l jazz -l rock -l /home/fez/ambient ... \n");
fprintf(pipey," -L xxx  Similar to -l, but walk all subdirs too.\n");
fprintf(pipey,"         You can string several -L together to load several trees.\n");
fprintf(pipey,"         You can combine -l and -L options....\n");
fprintf(pipey,"         -L will not follow symbolically linked directories.\n");
fprintf(pipey,"         e.g. jooky -l jazz -l rock -L /home/mp3 ... )\n");
fprintf(pipey,"\n");
fprintf(pipey," -t xxx  accept connections on port xxx instead of port %d\n",port);
fprintf(pipey,"\n");
fprintf(pipey,"client options\n");
fprintf(pipey,"%10.10s [-i host] [-t port] {-q|-n|-b|-p|-c|-r|-T} [-P xxx]\n",iam);
fprintf(pipey,"\n");
fprintf(pipey," -i      host connect to host (default localhost)\n");
fprintf(pipey," -t      port (default %d)\n",PORT);
fprintf(pipey," -q      stop\n");
fprintf(pipey," -n      next\n");
fprintf(pipey," -b      back\n");
fprintf(pipey," -p      pause\n");
fprintf(pipey," -c      continue (unpause)\n");
fprintf(pipey," -r      restart current title\n");
fprintf(pipey," -T      query current title\n");
fprintf(pipey," -P xxx  specify a password\n");
pclose(pipey);
}
