#include <asm/vga.h>
#include <pwd.h>
#include <time.h>
#include <fcntl.h>
#include <stdio.h>
#include <error.h>
#include <errno.h>
#include <netdb.h>
#include <curses.h>
#include <malloc.h>
#include <dirent.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/utsname.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <ftw.h>

#include "defines.h"

DIR *mp3dirhandle ;
struct dirent *mp3dir ;
struct dirent **sortedlist ;

struct mp3ent
{
	char *dir ;
	char *fname ;
	int played;
	struct mp3ent *next ;
	struct mp3ent *prev ;
};

struct mp3ent *first ;
struct mp3ent *last ;
struct mp3ent *curr ;
struct mp3ent *dument ;
struct mp3ent *justplayed ;

struct mp3playerdata
{
	char *player;
	char *playerflags[10];
	char *playeroutput;
	char *filetype;
	char *comment;
	int  filefirst;
};

struct WAVEHDR{
	char		format[4];		/* RIFF */
	unsigned long   f_len;			/* filelength */
	char		wave_fmt[8];		/* WAVEfmt_ */
	unsigned long   fmt_len;		/* format lenght */
	unsigned short  fmt_tag;		/* format Tag */
	unsigned short  channel;		/* Mono/Stereo */
	unsigned long   samples_per_sec;
	unsigned long   avg_bytes_per_sec;
	unsigned short  blk_align;
	unsigned short  bits_per_sample;
	char		data[4];		/* data */
	unsigned long   data_len;		/* data size */
} wavehdr;

struct utsname hosty;

struct mp3playerdata mp3player[10];

char *actstr[32];

char *mp3directory[1024] ;

char *iam ;
char *clockout ;

char *host;

char *argstart ;
char *lastargv ;
char *player[MAXPLAYERS] ;
char *playerdir[MAXPLAYERS] ;
char *playerflags[10][MAXPLAYERS] ;
char *playeroutput[MAXPLAYERS] ;

char *userid ;
char *readline ;
char *returnstring ;
char *setupfilename ;
char *otestfn ;
char *junk ;

char *more ;

char *extenshun ;

char *password ;
char *guess ;

char *hostname ;
char *mixcontrol;
char *mixsetting;
/* char *sttysetting; */
char *mixstart;

FILE *setupfile ;
FILE *ttyout ;
FILE *otest ;
FILE *jookyerr ;
FILE *tmppipe ;
FILE *dsp ;

WINDOW *win ;
SCREEN *screen ;

long clockoutptr ;

        int their_size;
        int bl;
        char *stringy;
        char *instring;

        struct sockaddr_in sokitin;
        struct sockaddr_in their_addr;


time_t starttime;
time_t nowtime;
time_t timey;

long int aa;

int fd;
int port;
int new_fd;
int msgcountback[256];
int sockets[2];
char sockbuf[256];
char *squig[5];
int squigpos ;
int loopies ;

int debug ;
int redrawing ;
int oldlines ;
int oldcols ;
int playthis ;
int sockopt ;
int sockoptlen ;
int useclient ;
int envpsize ;
int pssize ;
int argvlength ;
int key ;
int count ;
int playerpid ;
int displaypid ;
int pidstatus ;
int lockfilehan ;
int argy ;
int qq ;
int i,x ;
int scramble ;
int quit ;
int todo ;
int rep ;
int daemonize ;
int daemonstat ;
int counterpid ;
int futabapid ;
int socketpid ;
int usefutaba ;
int usemp3blaster ;
int quiet ;
int stepping ;
int hangingon ;
int dirhasbeenloaded ;
int defaultplayer ;
int playertouse[MAXFORMATS] ;
int verbose ;
int oldcurs ;
int usesocket ;
int numberoffiles ;
int playerselected ;
int titlequery ;
int mp3dirnum ;
int usepasswd ;
int nocheckdsp ;
int filefirst[MAXFORMATS] ;
/* int sttypresent ; */
int aumixpresent;
int startpoint;
int endpoint;
