#include "defines.h"
#include "includes.h"
#include "funcs.h"

int main(argc, argv, envp)
	int argc;
	char **argv[];
	char **envp[];
{
	extern char **environ;

	initvars();

	strcpy(iam,(char *)argv[0]);
	argstart=(char *)argv[0];

	nice(-5);

        for (i = 0; envp[i] != NULL; i++)
                envpsize += strlen((char *)envp[i]) + 1;
        environ = (char **) malloc(sizeof (char *) * (i + 1));
        for (i = 0; envp[i] != NULL; i++)
                environ[i] = strcpy((char *)calloc(1,strlen((char *)envp[i]) + 1), (char *)envp[i]);
        environ[i] = NULL;


        for (qq = 0; qq < argc; qq++)
        {
                if (qq==0 || ((char *)(lastargv + 1) == (char *)argv[qq]))
		{
			lastargv = (char *)argv[qq];
			lastargv = (char *)(lastargv + strlen((char *)argv[qq]));
		}
                else
                        continue;
        }

	for (qq = 0; envp[qq] != NULL; qq++)
	{
		if (qq==0 || (lastargv+1 == (char *)envp[qq]))
		{
			lastargv = (char *)envp[qq];
			lastargv = lastargv + strlen((char *)envp[qq]);
		}
		else
			continue;
	}

	pssize=(int)((long int)lastargv - (long int)argv[0]);

	mp3directory[mp3dirnum]=calloc(1,256);
	strcpy(mp3directory[mp3dirnum],MP3DIRECTORY);

	do
	{
		argy = getopt(argc,(char **)argv,"DNQqpcnbrTdszfm:o:w:h?l:L:i:t:P:");
		switch (argy)
		{
			case 'Q': if ((daemonize==0)&&(stepping==0)) {
					daemonize=2; /* means quiet */
					break;
				} else {
					printf ("Can specify only one of ");
					printf ("-d, -Q, or -s.\n");
					exit(1);
				}
				/* daemonize=2 doesn't daemonize */
				/* it just keeps it quiet */
			case 'q': todo=QUIT;     break;
			case 'p': todo=PAUSE;    break;
			case 'c': todo=RESUME;   break;
			case 'n': todo=NEXT;     break;
			case 'b': todo=PREV;     break;
			case 'r': todo=REPEAT;   break;
			case 'T': todo=QUERY;    break;
			case 'N': nocheckdsp=1;  break;
			case 'D': debug=1;       break;
			case 'd': if ((daemonize==0)&&(stepping==0)) {
					daemonize=1;
					break;
				} else {
					printf ("Can specify only one of ");
					printf ("-d, -Q, or -s.\n");
					exit(1);
				} ;
			case 's': if (daemonize!=0)
				{
					printf ("Can specify only one of ");
					printf ("-d, -Q, or -s.\n");
					exit(1);
				} else {
					stepping=1;hangingon=1;  break;
				}
			case 'z': scramble=1;  break; /* no repeats */
			case 'f': usefutaba=1; break;
			case 'm': playertouse[MP3]=atoi(optarg); break;
			case 'o': playertouse[OGG]=atoi(optarg); break;
			case 'w': playertouse[OGG]=atoi(optarg); break;
			case 'h': help();          exit(0);
			case '?': help();          exit(0);
			case 'l': if (mp3directory[mp3dirnum] == NULL) {
					  mp3directory[mp3dirnum]=calloc(1,DIRLEN +1);
				  }
				  strcpy(mp3directory[mp3dirnum++],optarg); break;
			case 'L': ftw(optarg,adddir,64);
			case 'i': strcpy(host,optarg);useclient=1; break;
			case 't': port=atoi(optarg); break;
			case 'P': strcpy(password,optarg);usepasswd=1; break;
	
			default: ;
		}
	} while (argy != EOF);
	debugger("setting up ps title.");
	memset(argv[0],0,pssize);
	if (usesocket==1)
		sprintf((char *)argv[0],(char *)"Jooky! ver. %s (c) 1999 by Dentar, Inc. (listening on port %d)",VERSION,port);
	else
		sprintf((char *)argv[0],(char *)"Jooky! ver. %s (c) 1999 by Dentar, Inc.",VERSION);

	debugger("testing whether client or server");
	if (todo != 0)
	{
		jookyclient(host,actstr[todo]);
	}

	debugger("searching for players and other programs");
	if (findplayers()==(char *)NULL)
	{
		printf ("I can't find any programs!!\n");
		exit (1);
	}

	if (aumixpresent==1)
	{
		debugger("attaching to mixer");
		aumixer();
	}

	debugger("checking to see if I daemonize");
	if (daemonize==1)
	{
		daemonstat=fork();
		if (daemonstat>0) 
		{
			printf ("Daemonized!\n");
			exit(0);
		}

		if (daemonstat<0)
		{
			printf ("Can't daemonize!\n");
			exit(-1);
		}

		if (daemonstat==0)
		{
			memset(argv[0],0,pssize);
			if (usesocket==0)
			sprintf((char *)argv[0],(char *)"Jookyd! ver. %s (c) 1999-2002 by Dentar, Inc.",VERSION);
			else
			sprintf((char *)argv[0],(char *)"Jookyd! ver. %s (c) 1999-2002 by Dentar, Inc. (listening on port %d)",VERSION,port);
			argv[1]=NULL;
		}
	}

	debugger("creating lock file");
	if (createlockfile()!=0)
	{
		fprintf(stdout,"Already running!\n");
		exit(-1);
	}

	debugger("loading directory");
	if (loaddir()!=0) exit (-1);
	debugger("loaded directory");

	setuphandlers();

	if (daemonize==0)
	{
		initscr();
		start_color();
		halfdelay(1);
		noecho();
		oldcurs=curs_set(0);
		oldlines=LINES;
		oldcols=COLS;
		keypad(stdscr,1);
		if (has_colors()==1)
		{
			init_pair(WHITEONBLACK,COLOR_WHITE   ,COLOR_BLACK); /* 0 */
			init_pair(WHITEONBLUE,COLOR_WHITE   ,COLOR_BLUE); /* 1 */
			init_pair(BLACKONCYAN,COLOR_BLACK   ,COLOR_CYAN); /* 2 */
			init_pair(WHITEONRED,COLOR_WHITE   ,COLOR_RED); /* 3 */
			init_pair(YELLOWONRED,COLOR_YELLOW  ,COLOR_RED); /* 4 */
			init_pair(WHITEONMAGENTA,COLOR_WHITE   ,COLOR_MAGENTA); /* 5 */
			init_pair(YELLOWONBLUE,COLOR_YELLOW  ,COLOR_BLUE); /* 6 */
			init_pair(MAGENTAONBLUE,COLOR_MAGENTA ,COLOR_BLUE); /* 7 */
			init_pair(BLACKONBLUE,COLOR_BLACK   ,COLOR_BLUE); /* 8 */
			init_pair(CYANONBLUE,COLOR_CYAN    ,COLOR_BLUE); /* 9 */
			init_pair(GREENONBLUE,COLOR_GREEN  ,COLOR_BLUE); /* 10 */
			init_pair(REDONBLUE,COLOR_RED    ,COLOR_BLUE); /* 11 */
			init_pair(YELLOWONWHITE,COLOR_YELLOW ,COLOR_WHITE); /* 12 */
			init_pair(REDONWHITE,COLOR_RED    ,COLOR_WHITE); /* 13 */
			init_pair(BLACKONWHITE,COLOR_BLACK  ,COLOR_WHITE); /* 14 */
			init_pair(BLACKONRED,COLOR_BLACK  ,COLOR_RED); /* 15 */
		}
		wattron(stdscr,COLOR_PAIR(WHITEONBLUE));
		wbkgdset(stdscr,COLOR_PAIR(WHITEONBLUE));
		wbkgd(stdscr,COLOR_PAIR(WHITEONBLUE));
	}
	else
	{
		debugger("NOT redirecting stdin, stdout and stderr to null.");
		if (debug==0) {
			freopen("/dev/null","a+",stdin);
			freopen("/dev/null","a+",stdout);
			freopen("/dev/null","a+",stderr);
		}
	}

	debugger("got past the redir, now testing if socket is to be used.");

	if (usesocket==1)
	{
		debugger("use socket is 1");
		fd=socket(AF_INET,SOCK_STREAM,0);
	
		sokitin.sin_family = AF_INET;
		sokitin.sin_port = htons(port);
		sokitin.sin_addr.s_addr=INADDR_ANY;
		memset(&sokitin.sin_zero,0,8);

		if (setsockopt(fd,SOL_SOCKET,SO_REUSEADDR,(char *)&sockopt,sockoptlen)!=0) {
			debugger("dang socket error");
			jookyerr=fopen("/tmp/jooky.err","w+");
			fprintf(jookyerr,"setsockopt: %s\n",strerror(errno));
			fclose(jookyerr);
			removelockfile();
			exit(errno);
		}
	
		if (bind(fd,(struct sockaddr *)&sokitin,sizeof(struct sockaddr)) == -1)
		{
			debugger("dang bind error");
			jookyerr=fopen("/tmp/jooky.err","w+");
			fprintf(jookyerr,"bind: %s\n",strerror(errno));
			fclose(jookyerr);
			fprintf(stderr,"bind: %s\n",strerror(errno));
			usesocket=0;
			removelockfile();
			exit(errno);
		}
	
		if (listen(fd,bl)==-1)
		{
			debugger("dang listener error");
			jookyerr=fopen("/tmp/jooky.err","w+");
			fprintf(jookyerr,"listen: %s\n",strerror(errno));
			fclose(jookyerr);
			usesocket=0;
		}
	}

	debugger("past the first use socket is 1");

	if (usesocket==1) fcntl(fd,F_SETFL,O_NONBLOCK);

	debugger("past the second use socket is 1 (fcntl)");

	if (uname(&hosty)==0)
	{
		hostname=calloc(1,1024);
		strcpy((char *)hostname,(char *)&hosty.nodename);
	}

	debugger("past the uname (hosty)");
	
	if (daemonize==0)
	{
		printskel(); 
	}

	debugger("past the printskel");
	if (stepping==1) curr=curr->next;
	for (;;)  /* do this til the end of time */
	{
		justplayed=curr;

		if ((redrawing==0)&&(hangingon==0))
			curr=curr->next;

		if (scramble==1)
		{
			move(STATUSLINE,0);
			clrtoeol();
			attrset(COLOR_PAIR(9)+A_BOLD);
			mvprintw(STATUSLINE,((COLS/2)-(strlen(SCRAMBLING))/2),SCRAMBLING);
			msgcountback[STATUSLINE]=10;
			clrtoeol();
			timey=time(&timey);
			srandom((unsigned int)timey);
			/* random scrambling */
			aa=random() % listlength(curr) ;
			for (x=0;x<=aa;++x) curr=curr->next;
			x=0;
			while (curr->played==1) {
				if (debug==1) printf ("x is %d and curr->played is %d\n",x,curr->played);
				++x;
				curr=curr->next;
				if (x > listlength(curr))
				{
					if (debug==1) printf ("x is %d and listlength is %d\n",x,listlength(curr));
					move(STATUSLINE,0);
					clrtoeol();
					attrset(COLOR_PAIR(9)+A_BOLD);
					mvprintw(STATUSLINE,((COLS/2)-(strlen(RESETTINGPLAYLIST))/2),RESETTINGPLAYLIST);
					msgcountback[STATUSLINE]=10;
					clrtoeol();
					while (curr->played==1)
					{
						curr->played=0;
						curr=curr->next;
					}
					x=0;
					justplayed->played=1;
				}
			}
			if (curr==justplayed) curr=curr->next;
		}

/*		else
			printskel(); */
		if (daemonize==0)
		{
			debugger("inside daemonize==0");
			dument=curr;
			if ( ((LINES-4) - (STATUSLINE+1)) > listlength(curr))
			{
				debugger(" list smaller than screen");
				startpoint=( ((((LINES-4) - (STATUSLINE+1)) / 2)+(STATUSLINE+1)) - ((listlength(curr)/2)) + 1);
				endpoint=( ((((LINES-4) - (STATUSLINE+1)) / 2)+(STATUSLINE+1)) + ((listlength(curr)/2)) + (isodd(listlength(curr))?1:0));
				for (qq=(listlength(curr)/2);qq>0;--qq) dument=dument->prev;
			} else 
			{
				for (qq=(LINES-STATUSLINE-4)/2;qq>0;--qq) dument=dument->prev;
				debugger(" list bigger than screen");
				startpoint=STATUSLINE+1;
				endpoint=LINES-4;
			}
			for (qq=startpoint;qq<=endpoint;++qq)
			{
				move(qq,0);
				clrtoeol();
				if (dument==curr)
				{
					attrset(A_STANDOUT);
				} else {
					if ( ((int)extenshun=(strrchr(dument->fname,'.')+1)) !=1 )
					{
						if ( ((strncasecmp(extenshun,"mp3",3)==0) && (player[MP3]!=NULL)) ||
						     ((strncasecmp(extenshun,"wav",3)==0) && (player[WAV]!=NULL)) ||
						     ((strncasecmp(extenshun,"ogg",3)==0) && (player[OGG]!=NULL)) )
						{
							attrset(A_BOLD);
						} else
						{
							attrset(A_NORMAL);
						}
					} else {
						attrset(A_NORMAL);
					}
				}
				mvaddnstr(qq,(strlen(dument->fname)<(COLS))?((COLS/2)-(strlen(dument->fname)/2)):0,dument->fname,COLS);
				dument=dument->next;
			} /* end of the loop that prints the list of titles */
		}
		debugger("memset otestfn,0,256");
		memset(otestfn,0,256);
		strcat(otestfn,curr->dir);
		strcat(otestfn,"/");
		strcat(otestfn,curr->fname);
		debugger("geting ready to pick player");
		if ((otest=fopen(otestfn,"r"))!=(FILE *)NULL)
		{
			fclose(otest);

			/* next, let's pick our player */

			extenshun=strrchr(curr->fname,'.')+1;
			playthis=NONE;
			if ((int)extenshun>1)
			{
				if ((strncasecmp(extenshun,"mp3",3)==0) && (player[MP3]!=NULL))
					playthis=MP3 ;
				else if ((strncasecmp(extenshun,"wav",3)==0) && (player[WAV]!=NULL))
					playthis=WAV ;
				else if ((strncasecmp(extenshun,"ogg",3)==0) && (player[OGG]!=NULL))
					playthis=OGG ;
			}
			debugger("player picked");

			/* print current song title on titleline */

			if (daemonize==0)
			{
				attrset(COLOR_PAIR(GREENONBLUE)+A_BOLD);
				move(TITLELINE,0);
				debugger("attributes set and moved to titleline");
				clrtoeol();
				mvaddnstr(TITLELINE,((COLS/2)-(strlen(otestfn)/2))<COLS?(COLS/2)-(strlen(otestfn)/2):0,otestfn,COLS);

				/* print current player */

				attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
				sprintf(junk,"%s",player[playthis]==NULL?"NO PLAYER AVAILABLE!!":player[playthis]);
				move(DIRLINE,0);
				clrtoeol();
				mvaddnstr(DIRLINE,(COLS/2)-(strlen(junk)/2),junk,COLS-1);
				sprintf(junk,"%d entries",listlength(curr));
				mvaddnstr(DIRLINE,(COLS/4)-(strlen(junk)/2),junk,COLS-1);
				printskel();
				debugger("printskel");
			}

			/* print current mixer knob setting */
			/* print mixer setting for current knob as well */
			if (aumixpresent==1)
			{
				sprintf(junk,"%14.14s",aumixstat(mixcontrol));
				if (daemonize==0) {
					attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
					mvaddstr(DIRLINE,COLS-strlen(junk),junk);
				}
				sprintf(mixsetting,"aumix -%1.1s q",mixcontrol);
				debugger("getting mixer...");
				tmppipe=popen(mixsetting,"r");
				fgets(mixsetting,25,tmppipe);
				chopcr(mixsetting);
				if ((int)tmppipe>2) pclose(tmppipe);
			}

			/* check to see if we should, and possibly do, fork a new player out */

			/* wait until /dev/dsp is */
			/* closed before attempting to start the */
			/*  next player */
			if ((nocheckdsp==0) && (redrawing==0))
			{
				msgcountback[STATUSLINE]=5;
				time(&starttime);
				if (daemonize==0) refresh();
				debugger("checking dsp...");
				for (;(((dsp=fopen("/dev/dsp","w+"))==NULL)&&(nocheckdsp==0));)
				{
					if ( ((nowtime-starttime)>1) && ((nowtime-starttime)<=DSPCHECKTIME) )
					{
						if (daemonize==0)
						{
							sprintf(junk,"Waiting for /dev/dsp to close.");
							attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
							mvprintw(STATUSLINE,((COLS/2)-(strlen(junk)/2)),junk);
							refresh();
						}
					}
					if ((nowtime-starttime)>DSPCHECKTIME)
					{
						nocheckdsp=1;
						if (daemonize==0)
						{
							sprintf(junk,"Turning off /dev/dsp checking.");
							attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
							mvprintw(STATUSLINE,((COLS/2)-(strlen(junk)/2)),junk);
						}
						msgcountback[STATUSLINE]=20;
					}	
					time(&nowtime);
					usleep(2000); 
				}
				if ((int)dsp>1) fclose(dsp);
			}
			debugger("now getting ready to fork off player.");
			if (redrawing==0) playerpid=fork();
			if (playerpid==0)
			{
				memset(argv[0],0,pssize);
				argv[1]=NULL;
				if ( ((stepping==1)&&(hangingon==1)) || (playthis==NONE) )
				{
					if (stepping==1) debugger("stepping==1");
					if (hangingon==1) debugger("hangingon==1");
					if (playthis==NONE) debugger("playthis==NONE");
					debugger("i am jookyhangond.");
					sprintf((char *)argv[0],"jookyhangond [%s] [%s]",curr->dir,curr->fname);
					sleep(1);
					exit(0); 
				} else {
					debugger("i am jookyplayerd.");
					if (stepping==1) debugger("stepping==1");
					if (hangingon==1) debugger("hangingon==1");
					if (playthis==NONE) debugger("playthis==NONE");
					sprintf((char *)argv[0],"jookyplayerd [%s] [%s]",curr->dir,curr->fname);
					startplayer(curr->dir,curr->fname,playthis);
				}
			} else if (playerpid < 0)
			{
				perror ("Fork player in main failed");
				jookyerr=fopen("/tmp/jooky.err","w+");
				fprintf(jookyerr,"playerpid was < 0\n");
				fclose(jookyerr);
				removelockfile();
				exit(-1);
			} else if (playerpid > 0)
			{
				curr->played=1;
				if (redrawing==0)
				{
					if (counterpid!=0) kill(counterpid,SIGKILL);
					if (futabapid!=0) kill(futabapid,SIGKILL);
				}
				if ((daemonize==0) && (redrawing==0))
				{
					if (playthis!=NONE)
					{
						if (socketpair(AF_UNIX, SOCK_STREAM, 0, sockets)<0)	
						{
							perror ("Socketpair:");
							close(sockets[0]);
							close(sockets[1]);
							removelockfile(); 
							exit(1);
						} else
							fcntl(sockets[0],F_SETFL,O_NONBLOCK);
						if (hangingon==0)
						{
							counterpid=fork();
							if (counterpid==0)
							{
								memset(argv[0],0,pssize);
								argv[1]=NULL;
								argc=qq=0;
								if (playthis==MP3)
									qq=mp3hed(curr->dir,curr->fname);
								else if (playthis==WAV)
									qq=wavhed(curr->dir,curr->fname);
								else if (playthis==OGG)
									qq=ogghed(curr->dir,curr->fname);
								sprintf((char *)argv[0],"revcounterd [%d]",qq);
								revcounter(qq);
								exit(0);
							};
						};
					};
				};

				/* spawn off a futaba display daemon if requested */

				if ((usefutaba==1) && (redrawing==0))
				{
					futabapid=fork();
					if (futabapid==0)
					{
						signal(1,SIG_DFL);
						signal(15,SIG_DFL);
						memset(argv[0],0,pssize);
						argv[1]=NULL;
						qq=0;
						if (playthis==MP3)
							qq=mp3hed(curr->dir,curr->fname);
						else if (playthis==WAV)
							qq=wavhed(curr->dir,curr->fname);
						else if (playthis==OGG)
							qq=ogghed(curr->dir,curr->fname);
						sprintf((char *)argv[0],"futabad [%s] [%d]",curr->fname,qq);
						futaba(curr->fname,qq);
						exit(0);
					}
				}
				redrawing=0;
				while ((waitpid(playerpid,NULL,WNOHANG)==0)&&(redrawing==0))
				{
					if (daemonize==0)
					{
						if (hangingon==0)
						{
							if ((playthis==MP3)||(playthis==WAV)||(playthis==OGG))
							{
								if (read(sockets[0],clockout,1024)!=-1)
								{
									attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
									sprintf(junk,"  %5.5s  ",clockout);
									mvaddstr(TIMELINE,((COLS/2)-(strlen(junk)/2)),junk);
									attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
									sprintf(junk,"%25.25s",mixsetting);
									mvaddstr(TIMELINE,(COLS-strlen(junk)),junk);
									wattroff(stdscr,COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
									memset(clockout,0,256);
								};
							} else {
								wattron(stdscr,COLOR_PAIR(CYANONBLUE)+A_BOLD);
								mvaddstr(TIMELINE,(COLS/2)-6,"  <playing>  ");
							}
						} else {
							if (hostname!=NULL) mvaddstr(TIMELINE,0,hostname);

							sprintf(junk,"Hit SPACE or ENTER to play this or a navigation key to move.");
							attrset(COLOR_PAIR(REDONBLUE)+A_BOLD);
							mvaddstr(0,(COLS-strlen(junk))/2,junk);
						}
						key=getch();
						if ((COLS!=oldcols)||(LINES!=oldlines))
						{
							clear();
							redrawing=1;
						}
						oldcols=COLS;
						oldlines=LINES;
						attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
						squiggly();
						if ((key=='n')||(key=='j')||(key==KEY_DOWN))
						{
							if (stepping==1) {
								hangingon=1;
								curr=curr->next;
							}
							skipforward();
						}
						else if (((key==' ')||(key==10)) && (stepping==1))
						{
							hangingon=1-hangingon;
							skipbackward();
						}
						else if (key=='p') pauseplay();
						else if (key=='c') resumeplay();
						else if (key=='z') {
							scramble=1-scramble;
							if (scramble==1) {
								move(STATUSLINE,0);
								clrtoeol();
								attrset(COLOR_PAIR(9)+A_BOLD);
								mvprintw(STATUSLINE,((COLS/2)-(strlen(RANDOM))/2),RANDOM);
								msgcountback[STATUSLINE]=10;
								clrtoeol();
							} else {
								move(STATUSLINE,0);
								clrtoeol();
								attrset(COLOR_PAIR(9)+A_BOLD);
								mvprintw(STATUSLINE,((COLS/2)-(strlen(ORDERED))/2),ORDERED);
								msgcountback[STATUSLINE]=10;
								clrtoeol();
							}
						}
						else if (key=='r')
						{
							skipbackward();
						}
						else if ((key=='N')||(key=='J')||(key==KEY_NPAGE))
						{
							if (stepping==1) {
								hangingon=1;
								curr=curr->next;
							}
							for (qq=1;qq<((LINES-STATUSLINE-5)/2);++qq)
							{
								curr=curr->next;
							}
							skipforward();
						}
						else if ((key=='b')||(key=='k')||(key==KEY_UP))
						{
							if (stepping==1)
							{
								hangingon=1;
							}
							if (hangingon==0) skipbackward();
							skipbackward();
						}
						else if ((key=='B')||(key=='K')||(key==KEY_PPAGE))
						{
							if (stepping==1)
							{
								curr=curr->next;
								hangingon=1;
							}
							for (qq=0;qq<((LINES-STATUSLINE-2)/2);++qq) skipbackward();
						}
						else if ((key=='d')) 
						{
							if (curr!=curr->next)
							{
								move (startpoint,0);
								clrtoeol();
								move (endpoint,0);
								clrtoeol();
								curr=zap(curr);
								skipforward();
							} else {
								move(STATUSLINE,0);
								clrtoeol();
								attrset(COLOR_PAIR(9)+A_BOLD);
								mvprintw(STATUSLINE,((COLS/2)-(strlen(CANTDELL))/2),CANTDELL);
								msgcountback[STATUSLINE]=10;
								clrtoeol();

							}
						}
						else if ((key=='q')||(key==127)||(key==263)||(key==330)||(key==8)) 
						{
							removelockfile();
/*							curs_set(oldcurs); 
							move(LINES,0);
							use_default_colors(); */
							clear(); refresh(); /*
							if (!nocbreak()) printf ("nocbreak failed.\n");
							if (!echo()) printf ("echo failed.\n");
							if (!nl()) printf ("nl failed.\n");
							if (!refresh()) printf ("Refresh failed.\n"); */
/*		delscreen(stdscr); */
/*		sprintf(junk,"stty %s\n",sttysetting);
		system(junk);
		debugger("un-stty"); */
							endwin();

							printf ("Bye.\n");
							exit (0);
						}
						else if ((key=='m')&&(aumixpresent==1))
						{
							++mixcontrol;
							if (*mixcontrol==0) mixcontrol=mixstart;
							sprintf(junk,"    Mixer: %1.1s    ",mixcontrol);
							attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
							mvprintw(STATUSLINE,((COLS/2)-(strlen(junk)/2)),junk);
							msgcountback[STATUSLINE]=10;
							attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
							sprintf(junk,"%14.14s",aumixstat(mixcontrol));
							mvaddstr(DIRLINE,COLS-strlen(junk),junk);
							sprintf(mixsetting,"aumix -%1.1s q",mixcontrol);
							tmppipe=popen(mixsetting,"r");
							fgets(mixsetting,25,tmppipe);
							chopcr(mixsetting);
							if ((int)tmppipe>2) fclose(tmppipe);
							sprintf(junk,"%25.25s",mixsetting);
							mvaddstr(TIMELINE,(COLS-strlen(junk)),junk);
						}
						else if ((key==KEY_RIGHT)&&(aumixpresent==1))
						{
							sprintf(mixsetting,"aumix -%1.1s +5",mixcontrol);
							system(mixsetting);
							sprintf(mixsetting,"aumix -%1.1s q",mixcontrol);
							tmppipe=popen(mixsetting,"r");
							fgets(mixsetting,25,tmppipe);
							chopcr(mixsetting);
							if ((int)tmppipe>2) fclose(tmppipe);
							attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
							mvprintw(STATUSLINE,((COLS/2)-7),"              ");
							mvprintw(STATUSLINE,(COLS-strlen(mixsetting))/2,mixsetting);
							msgcountback[STATUSLINE]=10;
							attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
							sprintf(junk,"%25.25s",mixsetting);
							mvaddstr(TIMELINE,(COLS-strlen(junk)),junk);
						}
						else if ((key==KEY_LEFT)&&(aumixpresent==1))
						{
							sprintf(mixsetting,"aumix -%1.1s -5",mixcontrol);
							system(mixsetting);
							sprintf(mixsetting,"aumix -%1.1s q",mixcontrol);
							tmppipe=popen(mixsetting,"r");
							fgets(mixsetting,25,tmppipe);
							chopcr(mixsetting);
							if ((int)tmppipe>2) fclose(tmppipe);
							attrset(COLOR_PAIR(CYANONBLUE)+A_BOLD);
							mvprintw(STATUSLINE,((COLS/2)-7),"              ");
							mvprintw(STATUSLINE,(COLS-strlen(mixsetting))/2,mixsetting);
							msgcountback[STATUSLINE]=10;
							attrset(COLOR_PAIR(YELLOWONBLUE)+A_BOLD);
							sprintf(junk,"%25.25s",mixsetting);
							mvaddstr(TIMELINE,(COLS-strlen(junk)),junk);
						}
						for (qq=9;qq>=0;--qq)
						{
							if (msgcountback[qq]==1)
							{
								move(qq,0);
								clrtoeol();
							}
							if (msgcountback[qq]>0) --msgcountback[qq];
						}
						if (hangingon==1)
							debugger("hanging on")
						else
							debugger("NOT hanging on");
					} else usleep(50000);
					if (usesocket==1)
						jookysock(curr->dir,curr->fname);
				}
				if ((daemonize==0)&&(usefutaba==0)&&(redrawing==0)&&(playthis!=NONE))
				{
					close(sockets[0]);
					close(sockets[1]);
				}
			}
			if ((stepping==1)&&((key!=' ')&&(key!=10)&&(key!=-1))) hangingon=1;
		} else
		{
			if (daemonize==0)
			{
				mvprintw(STATUSLINE,0,"Can't open %s!",curr->fname);
				clrtoeol();
				refresh();
			}
			usleep(300000);
			if (getch()=='q')
				removelockfile();
		}
	}
}
