#include "defines.h"
#include "includes.h"

void initvars()
{
	squig[0]=calloc(1,14);
	squig[1]=calloc(1,14);
	squig[2]=calloc(1,14);
	squig[3]=calloc(1,14);
	squig[4]=calloc(1,14);
	strcpy(squig[0],".    .    .    ");
	strcpy(squig[1]," .    .    .   ");
	strcpy(squig[2],"  .    .    .  ");
	strcpy(squig[3],"   .    .    . ");
	strcpy(squig[4],"    .    .    .");

	sockopt=1 ;
	debug=0 ;
	nocheckdsp=0 ;
	sockoptlen=sizeof(sockopt);
	usepasswd=0 ;
	titlequery=0 ;
	envpsize=0 ;
	pssize=0 ;
	argy=0 ;
	useclient=0 ;
	i=0 ;
	qq=0 ;
	bl=0;
	scramble=0 ;
	quit=0 ;
	todo=0 ;
	dirhasbeenloaded=0 ;
	playerselected=0 ;
	stepping=0;
	hangingon=0;
	redrawing=0;
	mp3dirnum=0;

	first=NULL ;
	last=NULL ;
	curr=NULL ;
	justplayed=NULL ;
	count=0 ;
	port=PORT ;
/*	sttypresent=0 ; */
	aumixpresent=0 ;
	counterpid=0 ;
	futabapid=0 ;
	playerpid=0 ;
	socketpid=0 ;
	pidstatus=0 ;
	daemonize=0 ;
	daemonstat=0 ;
	usefutaba=0 ;
	usesocket=1 ;
	playertouse[MP3]=0 ;
	playertouse[WAV]=3 ;
	playertouse[OGG]=4 ;
	clockout=calloc(1,256);
	otestfn=calloc(1,256);
	iam=calloc(1,256);
	host=calloc(1,256);
	password=calloc(1,80);
	guess=calloc(1,80);
	junk=calloc(1,1024);
	more=calloc(1,256);
/*	sttysetting=calloc(1,256); */
	mixsetting=calloc(1,256);

	strcpy(host,DEFAULTHOST);

	memset(&msgcountback[0],0,256);

	for (qq=0;qq<=31;++qq)
		actstr[qq]=calloc(1,10);

	strcpy(actstr[QUIT],"quit\n");
	strcpy(actstr[PAUSE],"paus\n");
	strcpy(actstr[RESUME],"resu\n");
	strcpy(actstr[PREV],"prev\n");
	strcpy(actstr[NEXT],"next\n");
	strcpy(actstr[REPEAT],"repe\n");
	strcpy(actstr[QUERY],"quer\n");

	for (qq=0;qq<=MAXPLAYERS;++qq)
	{
		mp3player[qq].player=calloc(1,80);
		for (x=0;x<=10;++x) mp3player[qq].playerflags[x]=calloc(1,80);
		mp3player[qq].playeroutput=calloc(1,80);
		mp3player[qq].filetype=calloc(1,80);
		mp3player[qq].comment=calloc(1,80);
	}

	strcpy(mp3player[1].player,"mp3blaster");
	strcpy(mp3player[1].playerflags[0],"-r=10");
	strcpy(mp3player[1].playeroutput,"/dev/tty11");
	strcpy(mp3player[1].filetype,"mp3");
	strcpy(mp3player[1].comment,"Command line curses based mp3 player");
	mp3player[1].filefirst=1;

	strcpy(mp3player[0].player,"mpg123");
	strcpy(mp3player[0].playerflags[0],"-q");
	strcpy(mp3player[0].playerflags[1],"--aggressive");
	strcpy(mp3player[0].playeroutput,"/dev/null");
	strcpy(mp3player[0].filetype,"mp3");
	strcpy(mp3player[0].comment,"Command line mp3 player");
	mp3player[0].filefirst=0;

	strcpy(mp3player[2].player,"freeamp");
	strcpy(mp3player[2].playeroutput,"/dev/null");
	strcpy(mp3player[2].filetype,"mp3");
	strcpy(mp3player[2].comment,"X-Based mp3 player (not recommended with jooky)");
	mp3player[2].filefirst=1;

	strcpy(mp3player[3].player,"sox");
	strcpy(mp3player[3].playerflags[0],"-t");
	strcpy(mp3player[3].playerflags[1],"ossdsp");
	strcpy(mp3player[3].playerflags[2],"/dev/dsp");
	strcpy(mp3player[3].playeroutput,"/dev/null");
	strcpy(mp3player[3].filetype,"wav");
	strcpy(mp3player[3].comment,"Command line wav player");
	mp3player[3].filefirst=1;

	strcpy(mp3player[4].player,"ogg123");
	strcpy(mp3player[4].playeroutput,"/dev/null");
	strcpy(mp3player[4].filetype,"ogg");
	strcpy(mp3player[4].comment,"Command line ogg player");
	mp3player[4].filefirst=1;

	strcpy(mp3player[5].player,"freeamp");
	strcpy(mp3player[5].playerflags[0],"-q");
	strcpy(mp3player[5].playeroutput,"/dev/null");
	strcpy(mp3player[5].filetype,"ogg");
	strcpy(mp3player[5].comment,"X-Based ogg player (not recommended with jooky)");
	mp3player[5].filefirst=1;

}
