#include "includes.h"
#include "defines.h"

int suhlektor(const struct dirent *dirstruct)
{
	struct stat *buffy;
	char *dirname;
	char *filename;
	int dooky;
	int dirlen;

	dirlen=16384;
	dirname=calloc(1,16384);
	filename=calloc(1,16384);
	buffy=(struct stat *)calloc(1,sizeof(struct stat));

	getcwd(dirname,dirlen);
	strcpy(filename,dirstruct->d_name);

	chdir(mp3directory[mp3dirnum]);
	dooky=stat(filename,buffy);
	chdir(dirname);
	if (debug==1) printf ("%d, %s, type %o\n",dooky,filename,buffy->st_mode);
	if (S_ISREG(buffy->st_mode)) {
		free(buffy);
		free(filename);
		free(dirname);
		return 1;
	} else {
		free(buffy);
		free(filename);
		free(dirname);
		return 0;
	}
}


int loadandsortdir()
{
/*	int iterations ;
	long int aa=0 ;
	long int bb=0 ;
        time_t timey; */

	struct dirent *tempfname ;

	tempfname=calloc(1,sizeof(struct dirent));

	numberoffiles = scandir(mp3directory[mp3dirnum], &sortedlist, suhlektor, alphasort);

	if (numberoffiles < 0)
	{
		perror("scandir");
		return -1;
	}

	return 0;
}
 
