#include "includes.h"
#include "funcs.h"
#include "defines.h"

int wavhed(char *dir, char *argy)
{

	int guess;

	char *filename;
	FILE *wavfile;

	filename=calloc(1,255);

	strcat(filename,dir);
	strcat(filename,"/");
	strcat(filename,argy);
	
	wavfile=fopen(filename,"r");
	
	if (wavfile==NULL)
	{
		mvaddstr(STATUSLINE,0,"Can't open the damn file.");
		clrtoeol();
		refresh();
		sleep(3);
		exit (1);
	}

	fread(&wavehdr,44,1,wavfile);
	fclose(wavfile);
	guess=wavehdr.f_len/wavehdr.avg_bytes_per_sec ;
	
	free(filename);
	return (int)guess;
}
